<template>
  <div>
    <div :class="{'preload': true,'hide': loadPage}">
      <div>
        <img src="./assets/load.gif" alt="">
      </div>
    </div>
    <div class="social_links">
      <a :href="author.facebook" target="_blank"><icon name="facebook" class="fa-icon"></icon></a>
      <a :href="author.instagram" target="_blank"><icon name="instagram" class="fa-icon"></icon></a>
      <a :href="author.behance" target="_blank"><icon name="behance" class=""></icon></a>
    </div>

    <div class="container">
      <!-- Header -->
      <div :class="{'header_wrap_default': true, 'header_wrap_img': headerWrapImg }">
        <div class="header">
          <div :class="{'header_title': true, 'header_title_visible': headerTitle}">
            <a href="">{{author.author_name}}<br/>{{author.author_surname}}</a>
          </div>
          <!-- Menu -->
          <div class="nav_wrap">
            <div class="menu-toggle-btn" @click="showHideMenu">
                <span></span>
                <span></span>
                <span></span>
            </div>
              <nav>
                <ul :class="{'open': showHideMenuFlag }">
                  <li class="" @click="goToLink"><router-link to="/">Главная</router-link></li>
                  <li class="" @click="goToLink"><router-link to="/about">О себе</router-link></li>
                  <li class="" @click="goToLink"><router-link to="/services">Услуги</router-link></li>
                  <li class="" @click="goToLink"><router-link to="/portfolio">Портфолио</router-link></li>
                  <li class="" @click="goToLink"><router-link to="/contacts">Контакты</router-link></li>
                </ul>
              </nav>
          </div>
        </div>
      </div>
      <transition name="page" mode="out-in">
        <router-view></router-view>
      </transition>
    </div>
  </div>
</template>

<script>

export default {
  name: 'app',
  data () {
    return {
      currentPath: '',
      headerWrapImg: false,
      headerTitle: false,
      showHideMenuFlag: false,
    }
  },
  computed: {
    author () {
      return this.$store.state.genInfo
    },
    loadPage () {
      return this.$store.state.loadPage
    }
  },

  created () {
    this.$store.dispatch('getGeneralInfo')
  },

  mounted () {
    this.currentPath = this.$router.history.current
    this.checkNavigation(this.currentPath)
  },

  watch: {
    '$route': function(path) {
      this.checkNavigation(path)
    }
  },

  methods: {
    checkNavigation (path) {
      this.headerTitle = this.headerWrapImg = path.name === 'Home'? false : true
    },

    showHideMenu () {
      this.showHideMenuFlag = !this.showHideMenuFlag
    },

    goToLink () {
      this.showHideMenuFlag = false
    }
  }
}
</script>

<style lang='scss'>
@import './assets/default.css';

/* page animation */
.page-enter-active, .page-leave-active {
  transition: opacity 0.6s, transform 0.6s;
}
.page-enter, .page-leave-to {
  opacity: 0;
  transform: translateX(-20%);
}
/* end page animation */

html {
    background-color: #ececec;
}

html, body {
    font-family: Verdana;
}

.container {
  z-index: 1;
}

/* fixed links*/

.social_links {
    position: fixed;
    top: 45%;
    display: inline-block;
    z-index: 1;

    a {
       cursor: pointer;
       margin-top: 10px;
       padding-top: 7px;
       padding-bottom: 2px;
       background-color: black;
       text-align: center;
       display: block;
       width: 40px;
       color: white;
   }
}

/* end fixed links*/

/* preload */
.preload {
  position: absolute;
  bottom: 0;
  top: 0;
  left: 0;
  right: 0;
  width: 100%;
  height: 100%;
  display: flex;
  justify-content: center;
  flex-direction: column;
  text-align: center;
  z-index: -10;
}

.preload img {
  width: 50px;
}

.hide {
  display: none;
}

/* end preload*/

/* start header navigation */

.header {
    max-width: 1200px;
    margin: auto;
    padding-top: 20px;
    padding-bottom: 20px;
    display: flex;
    justify-content:space-between;
}

li a.router-link-exact-active {
    border-bottom: 1px solid white;
}

.header_wrap_default {
    background-image: none;
    background-color: transparent;
}

.header_wrap_img {
    background-image: url('./assets/bg2.jpg');
}

.header_title {
    flex-basis: 300px;
    display: flex;
    justify-content: center;
    flex-direction: column;
    text-align: left;
    visibility: hidden;
    font-size: 18px;

    a {
        text-transform: uppercase;
        color: white;
        font-size: 18px;
    }
}

.header_title_visible {
    visibility: visible;
}

.nav_wrap ul {
    display: flex;
    z-index: 10;
    li {
        margin: 5px 20px;
        font-size: 14px;

        &.active {
            border: 1px solid #fff;
        }

        &:hover {
            a {
               color: lightgray;
            }
        }

        a {
            display: inline-block;
            width: 100%;
            color: #fff;
            cursor: pointer;
            padding: 5px 0px;
            margin: 10px 0px;
            white-space: nowrap;
            text-transform: uppercase;
        }
    }

    li:last-child {
      margin-right: 0px;
    }
}


.menu-toggle-btn{
  margin: 20px 40px 15px 15px;
  cursor: pointer;
  width: 30px;
  height: 25px;
  display: none;
}

.menu-toggle-btn span{
  background: #fff;
  display: block;
  width: 30px;
  height: 4px;
  border-radius: 5px;
  margin-bottom: 5px;
  -webkit-transition: all 0.5s linear;
  transition: all 0.3s linear;
}
.menu-toggle-btn.open span:nth-child(1), .menu-toggle-btn.open span:nth-child(3){
  transform: translate(0px, 13px) rotate(-45deg) scalex(1.3);
  margin: 0;
}

.menu-toggle-btn.open span:nth-child(2){ height: 0; margin: 0; }

.menu-toggle-btn.open span:nth-child(3){ transform: translate(0px, 9px) rotate(45deg) scalex(1.3); }


@media only screen and (max-width: 768px) {
  .header_title {
      margin-left: 25px;
  }
  .social_links {
      display: none;
  }

  .menu-toggle-btn span:nth-child(3){ margin-bottom: 0px; }

  .header { padding-top: 5px; padding-bottom: 5px; }

  .author_wrap { opacity: 1 !important; }

  .menu-toggle-btn{ display: block; }

  .nav_wrap {
      padding: 3px;

      ul {
          display: none;
          position: absolute;
          left: 0px;
          width: 100%;
          background-color: black;

          &.open {
             display: block;
          }
      }
  }
  .nav_wrap ul li  { border: 1px solid #3C3C3C; margin: 0px }

.nav_wrap  li a.router-link-exact-active {
      padding: 15px 10px;
      margin: 0px;
      border: 1px solid white;
  }

}

/* start header navigation */
</style>
